=begin
#Sunshine Conversations API

The version of the OpenAPI document: 9.4.5

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1
=end

require 'cgi'

module SunshineConversationsClient
  class AppKeysApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create App Key
    # Creates an API key for the specified app. The response body will include a secret  as well as its corresponding id, which you can use to generate JSON Web Tokens to  securely make API calls on behalf of the app. 
    # @param app_id [String] Identifies the app.
    # @param app_key_create_body [AppKeyCreateBody] 
    # @param [Hash] opts the optional parameters
    # @return [AppKeyResponse]
    def create_app_key(app_id, app_key_create_body, opts = {})
      data, _status_code, _headers = create_app_key_with_http_info(app_id, app_key_create_body, opts)
      data
    end

    # Create App Key
    # Creates an API key for the specified app. The response body will include a secret  as well as its corresponding id, which you can use to generate JSON Web Tokens to  securely make API calls on behalf of the app. 
    # @param app_id [String] Identifies the app.
    # @param app_key_create_body [AppKeyCreateBody] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AppKeyResponse, Integer, Hash)>] AppKeyResponse data, response status code and response headers
    def create_app_key_with_http_info(app_id, app_key_create_body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AppKeysApi.create_app_key ...'
      end
      # verify the required parameter 'app_id' is set
      if @api_client.config.client_side_validation && app_id.nil?
        fail ArgumentError, "Missing the required parameter 'app_id' when calling AppKeysApi.create_app_key"
      end
      # verify the required parameter 'app_key_create_body' is set
      if @api_client.config.client_side_validation && app_key_create_body.nil?
        fail ArgumentError, "Missing the required parameter 'app_key_create_body' when calling AppKeysApi.create_app_key"
      end
      # resource path
      local_var_path = '/v2/apps/{appId}/keys'.sub('{' + 'appId' + '}', CGI.escape(app_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(app_key_create_body) 

      # return_type
      return_type = opts[:return_type] || 'AppKeyResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth', 'bearerAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppKeysApi#create_app_key\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete App Key
    # Removes an API key.
    # @param app_id [String] Identifies the app.
    # @param key_id [String] The id of the key.
    # @param [Hash] opts the optional parameters
    # @return [Object]
    def delete_app_key(app_id, key_id, opts = {})
      data, _status_code, _headers = delete_app_key_with_http_info(app_id, key_id, opts)
      data
    end

    # Delete App Key
    # Removes an API key.
    # @param app_id [String] Identifies the app.
    # @param key_id [String] The id of the key.
    # @param [Hash] opts the optional parameters
    # @return [Array<(Object, Integer, Hash)>] Object data, response status code and response headers
    def delete_app_key_with_http_info(app_id, key_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AppKeysApi.delete_app_key ...'
      end
      # verify the required parameter 'app_id' is set
      if @api_client.config.client_side_validation && app_id.nil?
        fail ArgumentError, "Missing the required parameter 'app_id' when calling AppKeysApi.delete_app_key"
      end
      # verify the required parameter 'key_id' is set
      if @api_client.config.client_side_validation && key_id.nil?
        fail ArgumentError, "Missing the required parameter 'key_id' when calling AppKeysApi.delete_app_key"
      end
      # resource path
      local_var_path = '/v2/apps/{appId}/keys/{keyId}'.sub('{' + 'appId' + '}', CGI.escape(app_id.to_s)).sub('{' + 'keyId' + '}', CGI.escape(key_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'Object' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth', 'bearerAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppKeysApi#delete_app_key\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get App Key
    # Returns an API key.
    # @param app_id [String] Identifies the app.
    # @param key_id [String] The id of the key.
    # @param [Hash] opts the optional parameters
    # @return [AppKeyResponse]
    def get_app_key(app_id, key_id, opts = {})
      data, _status_code, _headers = get_app_key_with_http_info(app_id, key_id, opts)
      data
    end

    # Get App Key
    # Returns an API key.
    # @param app_id [String] Identifies the app.
    # @param key_id [String] The id of the key.
    # @param [Hash] opts the optional parameters
    # @return [Array<(AppKeyResponse, Integer, Hash)>] AppKeyResponse data, response status code and response headers
    def get_app_key_with_http_info(app_id, key_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AppKeysApi.get_app_key ...'
      end
      # verify the required parameter 'app_id' is set
      if @api_client.config.client_side_validation && app_id.nil?
        fail ArgumentError, "Missing the required parameter 'app_id' when calling AppKeysApi.get_app_key"
      end
      # verify the required parameter 'key_id' is set
      if @api_client.config.client_side_validation && key_id.nil?
        fail ArgumentError, "Missing the required parameter 'key_id' when calling AppKeysApi.get_app_key"
      end
      # resource path
      local_var_path = '/v2/apps/{appId}/keys/{keyId}'.sub('{' + 'appId' + '}', CGI.escape(app_id.to_s)).sub('{' + 'keyId' + '}', CGI.escape(key_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AppKeyResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth', 'bearerAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppKeysApi#get_app_key\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List App Keys
    # Lists all API keys for a given app.
    # @param app_id [String] Identifies the app.
    # @param [Hash] opts the optional parameters
    # @return [AppKeyListResponse]
    def list_app_keys(app_id, opts = {})
      data, _status_code, _headers = list_app_keys_with_http_info(app_id, opts)
      data
    end

    # List App Keys
    # Lists all API keys for a given app.
    # @param app_id [String] Identifies the app.
    # @param [Hash] opts the optional parameters
    # @return [Array<(AppKeyListResponse, Integer, Hash)>] AppKeyListResponse data, response status code and response headers
    def list_app_keys_with_http_info(app_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AppKeysApi.list_app_keys ...'
      end
      # verify the required parameter 'app_id' is set
      if @api_client.config.client_side_validation && app_id.nil?
        fail ArgumentError, "Missing the required parameter 'app_id' when calling AppKeysApi.list_app_keys"
      end
      # resource path
      local_var_path = '/v2/apps/{appId}/keys'.sub('{' + 'appId' + '}', CGI.escape(app_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AppKeyListResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth', 'bearerAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppKeysApi#list_app_keys\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
