=begin
#Sunshine Conversations API

The version of the OpenAPI document: 9.4.5

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1
=end

require 'date'

module SunshineConversationsClient
  class Twilio < Integration
    # To configure a Twilio integration, acquire the required information from the user and call the Create Integration endpoint. 
    attr_accessor :type

    # Twilio Account SID.
    attr_accessor :account_sid

    # Twilio Auth Token.
    attr_accessor :auth_token

    # SID for specific phone number. One of `messagingServiceSid` or `phoneNumberSid` must be provided when creating a Twilio integration.
    attr_accessor :phone_number_sid

    # SID for specific messaging service. One of `messagingServiceSid` or `phoneNumberSid` must be provided when creating a Twilio integration.
    attr_accessor :messaging_service_sid

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'type' => :'type',
        :'account_sid' => :'accountSid',
        :'auth_token' => :'authToken',
        :'phone_number_sid' => :'phoneNumberSid',
        :'messaging_service_sid' => :'messagingServiceSid'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'type' => :'String',
        :'account_sid' => :'String',
        :'auth_token' => :'String',
        :'phone_number_sid' => :'String',
        :'messaging_service_sid' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # List of class defined in allOf (OpenAPI v3)
    def self.openapi_all_of
      [
      :'Integration',
      :'TwilioAllOf'
      ]
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `SunshineConversationsClient::Twilio` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `SunshineConversationsClient::Twilio`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      # call parent's initialize
      super(attributes)

      if attributes.key?(:'type')
        self.type = attributes[:'type']
      else
        self.type = 'twilio'
      end

      if attributes.key?(:'account_sid')
        self.account_sid = attributes[:'account_sid']
      end

      if attributes.key?(:'auth_token')
        self.auth_token = attributes[:'auth_token']
      end

      if attributes.key?(:'phone_number_sid')
        self.phone_number_sid = attributes[:'phone_number_sid']
      end

      if attributes.key?(:'messaging_service_sid')
        self.messaging_service_sid = attributes[:'messaging_service_sid']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = super
      if @account_sid.nil?
        invalid_properties.push('invalid value for "account_sid", account_sid cannot be nil.')
      end

      if @auth_token.nil?
        invalid_properties.push('invalid value for "auth_token", auth_token cannot be nil.')
      end

      if @auth_token.to_s.length < 1
        invalid_properties.push('invalid value for "auth_token", the character length must be great than or equal to 1.')
      end

      if !@phone_number_sid.nil? && @phone_number_sid.to_s.length < 1
        invalid_properties.push('invalid value for "phone_number_sid", the character length must be great than or equal to 1.')
      end

      if !@messaging_service_sid.nil? && @messaging_service_sid.to_s.length < 1
        invalid_properties.push('invalid value for "messaging_service_sid", the character length must be great than or equal to 1.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @account_sid.nil?
      return false if @auth_token.nil?
      return false if @auth_token.to_s.length < 1
      return false if !@phone_number_sid.nil? && @phone_number_sid.to_s.length < 1
      return false if !@messaging_service_sid.nil? && @messaging_service_sid.to_s.length < 1
      true && super
    end

    # Custom attribute writer method with validation
    # @param [Object] auth_token Value to be assigned
    def auth_token=(auth_token)
      if auth_token.nil?
        fail ArgumentError, 'auth_token cannot be nil'
      end

      if auth_token.to_s.length < 1
        fail ArgumentError, 'invalid value for "auth_token", the character length must be great than or equal to 1.'
      end

      @auth_token = auth_token
    end

    # Custom attribute writer method with validation
    # @param [Object] phone_number_sid Value to be assigned
    def phone_number_sid=(phone_number_sid)
      if !phone_number_sid.nil? && phone_number_sid.to_s.length < 1
        fail ArgumentError, 'invalid value for "phone_number_sid", the character length must be great than or equal to 1.'
      end

      @phone_number_sid = phone_number_sid
    end

    # Custom attribute writer method with validation
    # @param [Object] messaging_service_sid Value to be assigned
    def messaging_service_sid=(messaging_service_sid)
      if !messaging_service_sid.nil? && messaging_service_sid.to_s.length < 1
        fail ArgumentError, 'invalid value for "messaging_service_sid", the character length must be great than or equal to 1.'
      end

      @messaging_service_sid = messaging_service_sid
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          type == o.type &&
          account_sid == o.account_sid &&
          auth_token == o.auth_token &&
          phone_number_sid == o.phone_number_sid &&
          messaging_service_sid == o.messaging_service_sid && super(o)
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [type, account_sid, auth_token, phone_number_sid, messaging_service_sid].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      super(attributes)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        SunshineConversationsClient.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = super
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
